/****************************************************************************
 *  Copyright (c) 2015 RT-RK d.o.o
 *
 *  All Rights Reserved
 *
 *  P R O P R I E T A R Y    &    C O N F I D E N T I A L
 *
 *  -----------------------------------------------------
 *  http://www.rt-rk.com
 *  -----------------------------------------------------
 *
 * \project Oblo Message Broker - messaging library
 * \file Common.h
 * \brief
 * Common defines and global functions.
 *
 * @Author Milan Tucic
 *
 * \notes
 *
 * \history
 *****************************************************************************/
#ifndef OBLO_MESSENGER_COMMON_H
#define OBLO_MESSENGER_COMMON_H

#if defined(WIN32) || defined(WIN64)
    #define DLLImport __declspec(dllimport)
    #define DLLExport __declspec(dllexport)
#else
    #define DLLImport extern
    #define DLLExport __attribute__ ((visibility ("default")))
#endif

#define SAFE_DELETE_O(p) delete p; p = NULL;
#define SAFE_DELETE_ARRAY_O(a) delete [] a; a = NULL;

#define SMLOG(plog, lvl, msg) { \
    if( plog ) { \
        std::stringstream ss; \
        ss << msg; \
        plog->On##lvl(ss.str());\
    } \
}

#include <string>

namespace Messenger {

char* DuplicateString(const std::string& _szBuff);

}

#endif
