/****************************************************************************
 *  Copyright (c) 2018 OBLO Living LLC
 *
 *  All Rights Reserved
 *
 *  P R O P R I E T A R Y    &    C O N F I D E N T I A L
 *
 *  -----------------------------------------------------
 *  http://www.rt-rk.com
 *  -----------------------------------------------------
 *
 * \project Oblo Message Broker - messaging library
 * \file MqttLogger.h
 * \brief
 * Logger for Paho's MQTT.
 *
 * @Author Milan Tucic
 *
 * \notes
 *
 * \history
 * 13.12.2018 - Initial version
 *****************************************************************************/
#ifndef OBLO_MESSENGER_MQTT_LOGGER_H
#define OBLO_MESSENGER_MQTT_LOGGER_H

#include "messenger/Logging.h"

namespace Messenger {
/**
 * @class CMqttLogger
 * @brief Logger for Paho's MQTT client specific messages.
 */
class DLLExport CMqttLogger {
public:
    static CMqttLogger& getInstance();
    // Set listener during application initialization, listener is not thread-safe.
    void SetListener(ILogListener* _pLogger);

    void OnTrace(const std::string& _Msg);
    void OnDebug(const std::string& _Msg);
    void OnInformation(const std::string& _Msg);
    void OnWarning(const std::string& _Msg);
    void OnError(const std::string& _Msg);
    void OnFatal(const std::string& _Msg);

private:
    CMqttLogger();
    ~CMqttLogger();
    CMqttLogger(CMqttLogger const&);
    void operator=(CMqttLogger const&);

    ILogListener* m_pLogger;
};

}
#endif
